

//  Fibo Grid (fxpm version )
//--------------------------------------------------------------
#property indicator_chart_window

extern int   Shift         = -97;
input int    Range_in_pips = 40;

int          Spacing       = 20;
int          Width         = 19;
int          MA_mode       = 0;

int          Width2 = 100;
int          VWidth = 20;

extern color neutral_col= C'255,255,255' ;

extern color up_col_1= C'255,200,200' ;
extern color up_col_2= C'250,150,150' ;
extern color up_col_3= C'240,100,100' ;
extern color up_col_4= C'220,50,50' ;
extern color up_col_5= C'200,0,0' ;
extern color up_col_6= C'160,0,0' ;

extern color down_col_1= C'200,255,200' ;
extern color down_col_2= C'150,250,150' ;
extern color down_col_3= C'100,240,100' ;
extern color down_col_4= C'50,210,50' ;
extern color down_col_5= C'0,180,0' ;
extern color down_col_6= C'0,140,0' ;

extern bool show_Fibo_Line=true;

extern bool D1_Show_Line=true;
extern bool D1_Show_Price=true;
input color D1_Highcol = FireBrick;
input color D1_Lowcol = Green;
input int D1_style = 2;

input color maFastColor=clrDodgerBlue;
input color maMiddleColor=clrGold;
input color maSlowColor=clrBlack;

input color fibHighColor=clrMediumSeaGreen;
input color fibLowColor=clrBrown;

input color fibHighTxtColor=clrWhite;
input color fibLowTxtColor=clrWhite;

input color fibR1Color=clrGreen;
input color fibR2Color=clrGreen;
input color fibR3Color=clrGreen;
input color fibPVColor=clrBlack;
input color fibS1Color=clrBlue;
input color fibS2Color=clrBlue;
input color fibS3Color=clrBlue;

extern bool Show_Daily_Info=true;

#define NSL    10       // number of shade levels
#define NMA    7       // number of MAs, change ma_period[NMA-1] accordingly 
#define NTF    5       // number of time frames/lanes, change tfp[NTF] accordinlgy

int      _bsl[NSL]    = {10, 16, 26, 42, 68, 111, 179, 290, 470, 760}; // time shades distance : 9, 16, 26, 42, 68, 110, 178, 246
int      ma_period[7] = {21,34,55,75,100,144,233};         // SMAs, NMA-1
int      tfp[NTF]     = {1,5,15,60,240};                   // Time frames/lanes - in minutes. Like H4=240, D1=1440 etc...

double   fml[NTF][NMA];                                    // momentum lines
double   bsl_up[NTF][NSL];                                 // color shades levels to the up side
double   bsl_down[NTF][NSL];                               // color shades levels to the down side
double   bsl[NSL];                                         // color shades distances ('point' adjusted)

double   tmpArray[NMA], lowestMA, highestMA;

double   price, point;
double   bar;

int     i,tf; 
double  offset, xUnit;
double  shift, spacing, width, width2, Vwidth;

string  objName;
string   uniqueid = "FXG: ";
datetime curTime;

double   PipPoints;
double Pointx;
double divider;
int x_digits;

int zoomState=-1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   xUnit   = Period() * 60;
   shift   = Shift * xUnit;
   spacing = Spacing * xUnit;
   width   = Width * xUnit;
   width2  = Width2 * xUnit;
   Vwidth  = VWidth * xUnit;
      
   point   = 0.01;
   if(Digits > 3) point = 0.0001;
   
   if(Digits==3 || Digits==5) PipPoints=Point*10;
   else     
      PipPoints=Point;
    
//----------------------------------
   //Spread: Check for 3 & 5 digit
   if (Point == 0.00001) Pointx = 0.0001; //5 digits
   else if (Point == 0.001) Pointx = 0.01; //3 digits
   else Pointx = Point; //Normal
  
   if (Pointx > Point)
      {
      divider = 10.0;
      x_digits = 1;
      }
   else 
      {
      divider = 1;
      x_digits = 0;
      }
//----------------------------------
         
   ChartSetInteger(0,CHART_SCALEFIX,true);
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE,false);
   ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,1);
   ChartSetDouble(0,CHART_FIXED_MAX,(Bid+(Range_in_pips*PipPoints)));
   ChartSetDouble(0,CHART_FIXED_MIN,(Bid-(Range_in_pips*PipPoints)));

//+------------------------------------------------------------------+
//| creating the objects for drawing the grid                        |
//+------------------------------------------------------------------+

   for(i=0; i<NSL; i++)  bsl[i] = _bsl[i]*point;
   
   for(tf=0; tf<NTF; tf++)
   {
      
     
      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fml_bar_" + tf + "_" + i;              // horizontal momentum lines
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);

         ObjectSet(objName, OBJPROP_COLOR, Black);
         ObjectSetInteger(NULL,objName,OBJPROP_FONTSIZE,8); 
       
         //if(i<2 || i == NMA-1) ObjectSet(objName, OBJPROP_WIDTH, 1); else ObjectSet(objName, OBJPROP_WIDTH, 0);
      }
     
   }
   
   drawTimeFrameHeader();
   EventSetMillisecondTimer(500);
   
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
      EventKillTimer();
      ObjectDelete("Bid");
  
      ObjectDelete(0,"Active_zone");
      
      ObjectDelete(0,"up_20");
      ObjectDelete(0,"up_30");
      ObjectDelete(0,"up_40");
      ObjectDelete(0,"up_50");
      ObjectDelete(0,"up_100");
      ObjectDelete(0,"up_ext");
//-----------------------------
      ObjectDelete(0,"down_20");   
      ObjectDelete(0,"down_30");      
      ObjectDelete(0,"down_40");
      ObjectDelete(0,"down_50");
      ObjectDelete(0,"down_100");      
      ObjectDelete(0,"down_ext");

//-----------------------------
      ObjectDelete(0,"vL_0");
      ObjectDelete(0,"vL_1");   
      ObjectDelete(0,"vL_2");
      ObjectDelete(0,"vL_3");
      ObjectDelete(0,"vL_4");
      ObjectDelete(0,"vL_5");
      
      ObjectDelete("High_line");   
      ObjectDelete("Low_line");    
      ObjectDelete("High_price");   
      ObjectDelete("Low_price"); 
   
      ObjectDelete("D1Range");   
      ObjectDelete("D1Change");       
      
      string lookFor       = uniqueid;
      int    lookForLength = StringLen(lookFor);   
      for(i = ObjectsTotal() - 1; i >= 0; i--)
      {
         string name = ObjectName(i);
            if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
      }
   return(0);
}


void OnTimer()
  {
   if (zoomState!=ChartGetInteger(0,CHART_SCALE)) drawTimeFrameHeader();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int X = -10, Y = 15, A = 10, B = 12;
   point   = 0.01;
   if(Digits > 3) point = 0.0001;
   
   ChartSetInteger(0,CHART_SCALEFIX,true);
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE,false);
   ChartSetDouble(0,CHART_FIXED_MAX,(Bid+(Range_in_pips*PipPoints)));
   ChartSetDouble(0,CHART_FIXED_MIN,(Bid-(Range_in_pips*PipPoints)));
   
   ObjectDelete("Bid");
   ObjectCreate(NULL,"Bid",OBJ_HLINE,0,0,Bid);
   ObjectSet("Bid",OBJPROP_STYLE,5);
   ObjectSet("Bid",OBJPROP_COLOR,clrBlack);
   ObjectSet("Bid",OBJPROP_SELECTABLE,false);

//+------------------------------------------------------------------+
//| Time lines                                                       |
//+------------------------------------------------------------------+

   curTime = Time[1]; 
   price   = Close[0];
    
   for(tf=0; tf<NTF; tf++)
   {
      bar = iBarShift(NULL, tfp[tf], curTime, false);
      for(i=0; i<NMA; i++){
        fml[tf][i] = iMA(NULL, tfp[tf], ma_period[i], 0, MA_mode, PRICE_CLOSE, bar/Period());  // populating the fml array...
        tmpArray[i] = fml[tf][i];                                                              // finding the highest and lowest MAs from the (7) fml's/MA's
      }
      ArraySort(tmpArray);                                                                                         // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
      lowestMA  = tmpArray[0];
      highestMA = tmpArray[6];

      for(i=0; i<NSL; i++)                                                                                         // populating the bsl arrays...
      {
         bsl_up[tf][i]   = lowestMA  + bsl[i];
         bsl_down[tf][i] = highestMA - bsl[i];
      }
      
   }

//+------------------------------------------------------------------+
//| drawing the color shades of the grid from top to bottom          |
//+------------------------------------------------------------------+

   for(tf=0; tf<NTF; tf++) 
   {
   
     offset = 0;                                                                
      for(i=offset; i<NSL-1; i++) if(bsl_up[tf][i] <= bsl_down[tf][i]) offset++;
        
      double highest=0;
      for(i=NSL-2; i>=offset; i--)
      {
                
         if (bsl_down[tf][i]>highest) highest=bsl_up[tf][i+1];
         objName = uniqueid+"bsl_high_bg_"+tf+"_"+(i-offset);
         
         ObjectDelete(NULL,objName);
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);

         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
         ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,11);
         ObjectSetString(NULL,objName, OBJPROP_FONT, "Webdings");
         ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,3);
                  
         if (bsl_up[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,fibHighColor);
            else 
               ObjectSet(objName, OBJPROP_COLOR,fibLowColor);
         //ObjectSet(objName, OBJPROP_BACK,true);
         ObjectSetText(objName,CharToStr(0x67));
                
         
         objName = uniqueid+"bsl_up_bar_"+tf+"_"+(i-offset);

         ObjectDelete(NULL,objName);
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);

         ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,7);
         ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
         
       
         if (bsl_up[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,fibHighTxtColor);
            else 
               ObjectSet(objName, OBJPROP_COLOR,fibLowTxtColor);
         

         ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,3);
         string upper = DoubleToString(bsl_up[tf][i],Digits);
         int SLength = StringLen(upper);
         string upperL = StringSubstr(upper, SLength-3, 2);
         //ObjectSet(objName, OBJPROP_BACK,true);
         ObjectSetText(objName, upperL);
            
      }

    double lowest=9999.9999;
      for(i=0; i<NSL-1; i++)
      {
         
         if(bsl_down[tf][i]<lowest) lowest=bsl_down[tf][i+1];
       
            objName = uniqueid+"bsl_low_bg_"+tf+"_"+(i-offset);
            ObjectDelete(NULL,objName);
            ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);

             if (bsl_down[tf][i]<price) ObjectSet(objName, OBJPROP_COLOR,fibLowColor);
             else 
               ObjectSet(objName, OBJPROP_COLOR,fibHighColor);
                       
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,11);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Webdings");
            ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,3);
            //ObjectSet(objName, OBJPROP_BACK,true);
            ObjectSetText(objName,CharToStr(0x67));
            

            objName = uniqueid+"bsl_down_bar_"+tf+"_"+(i-offset);
            ObjectDelete(NULL,objName);
            ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            
             if (bsl_down[tf][i]<price) ObjectSet(objName, OBJPROP_COLOR,fibLowTxtColor);
             else 
               ObjectSet(objName, OBJPROP_COLOR,fibHighTxtColor);
           ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,3);
            
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,7);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
               
            string lower = DoubleToString(bsl_down[tf][i],Digits);
            int SLength2 = StringLen(lower);
            string lowerL = StringSubstr(lower, SLength2-3, 2);
            //ObjectSet(objName, OBJPROP_BACK,true);
            ObjectSetText(objName, lowerL);
      }

      
         for(i=0; i<NMA; i++)
         {

          objName = uniqueid + "fml_bar_" + tf + "_" + i;
          ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+6*xUnit);
          ObjectSet(objName, OBJPROP_PRICE1, fml[tf][i]);

/*         ADX is nondirectional and quantifies trend strength by rising in both uptrends and downtrends.
           When the +DMI is above the -DMI, prices are moving up, and ADX measures the strength of the uptrend. 
           When the -DMI is above the +DMI, prices are moving down, and ADX measures the strength of the downtrend.

          0-25 	Absent or Weak Trend
         25-50 	Strong Trend
         50-75 	Very Strong Trend
         75-100 	Extremely Strong Trend

*/

          double adx=iADX(NULL,tfp[tf],ma_period[i],PRICE_CLOSE,MODE_MAIN,0);
          double dmiP=iADX(NULL,tfp[tf],ma_period[i],PRICE_CLOSE,MODE_PLUSDI,0);
          double dmiM=iADX(NULL,tfp[tf],ma_period[i],PRICE_CLOSE,MODE_MINUSDI,0);
     
                 if (adx<=25) ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,13);
                else
                if (adx>25&&adx<=50) ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,14);
                else
                if (adx>50&&adx<=75) ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,18);
                else
                if (adx>75&&adx<=100) ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,22);
                
          if (dmiP <= dmiM) { //down
                ObjectSetString(NULL,objName, OBJPROP_FONT, "Wingdings 3");
                ObjectSetText(objName,CharToStr(0x88));
          } else 
          if (dmiP > dmiM) {
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Wingdings 3");
            ObjectSetText(objName,CharToStr(0x87));
         }
                     
   
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
         
         if(i==0) ObjectSet(objName, OBJPROP_COLOR, maFastColor); 
            else 
               ObjectSet(objName, OBJPROP_COLOR, maMiddleColor);
         
         if(i==6){
 
         ObjectSet(objName, OBJPROP_COLOR, Black);
        
         double trendStrength=iADX(NULL,tfp[tf],ma_period[i],PRICE_CLOSE,MODE_PLUSDI,0);
         }
         else if (i<6 && i>1){
        
            ObjectDelete(NULL,objName+"_BG");
            ObjectCreate(objName+"_BG", OBJ_TEXT, 0, 0, 0, 0, 0);
            ObjectSet(objName+"_BG", OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
            ObjectSet(objName+"_BG", OBJPROP_PRICE1, fml[tf][i]);
            ObjectSetInteger(NULL,objName+"_BG",OBJPROP_ANCHOR,ANCHOR_CENTER);
            
            if (fml[tf][i]>=price) ObjectSet(objName+"_BG", OBJPROP_COLOR,fibHighColor);
               else 
                  ObjectSet(objName+"_BG", OBJPROP_COLOR,fibLowColor);
         
            ObjectSetInteger(NULL,objName+"_BG", OBJPROP_FONTSIZE,17);
            ObjectSetString(NULL,objName+"_BG", OBJPROP_FONT, "Wingdings 2");
            ObjectSetText(objName+"_BG",CharToStr(0x2A));
     
        
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,6);            

            if (fml[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,fibHighColor);
               else 
                  ObjectSet(objName, OBJPROP_COLOR,fibLowColor);
         
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fml[tf][i]);
            
            string labelString = DoubleToString(fml[tf][i],Digits);
            int SLength5 = StringLen(labelString);
            string maStringX = StringSubstr(labelString, SLength5-3, 2);        
            ObjectSetText(objName, maStringX);
         }
      }
   }
  
 
//------------------------------------------
   double  SMA_21 = iMA (0,1,21,0,0,0,0); 
 
/*   double  upSig = SMA_21+(5*PipPoints);
   double  downSig = SMA_21-(5*PipPoints);
 */
 
   
   double p20 = SMA_21+(20*PipPoints); 
   double p30 = SMA_21+(30*PipPoints); 
   double p40 = SMA_21+(40*PipPoints); 
   double p50 = SMA_21+(50*PipPoints); 
   double p100 = SMA_21+(100*PipPoints); 
   double p150 = SMA_21+(150*PipPoints); 

   double dp20 = SMA_21-(20*PipPoints); 
   double dp30 = SMA_21-(30*PipPoints); 
   double dp40 = SMA_21-(40*PipPoints); 
   double dp50 = SMA_21-(50*PipPoints); 
   double dp100 = SMA_21-(100*PipPoints); 
   double dp150 = SMA_21-(150*PipPoints); 
    
//-----------------------------------

   int  shift1 = (shift+Vwidth); 
   int  shift2 = (shift1+Vwidth);
   int  shift3 = (shift2+Vwidth);
   int  shift4 = (shift3+Vwidth);
      
   curTime = Time[0];  
     
//-------------------------------------------------------------
   ObjectDelete(0,"Active_zone");
   ObjectCreate(0,"Active_zone",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("Active_zone", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("Active_zone", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("Active_zone", OBJPROP_PRICE1, p20 );
   ObjectSet("Active_zone", OBJPROP_PRICE2, dp20 );
   ObjectSet("Active_zone", OBJPROP_COLOR,  neutral_col);
//-------------------------------------------------------------
   
   ObjectDelete(0,"up_20");
   ObjectCreate(0,"up_20",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_20", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("up_20", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("up_20", OBJPROP_PRICE1, p20 );
   ObjectSet("up_20", OBJPROP_PRICE2, p30 );
   ObjectSet("up_20", OBJPROP_COLOR,  up_col_1);
   
   ObjectDelete(0,"up_30");
   ObjectCreate(0,"up_30",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_30", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("up_30", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("up_30", OBJPROP_PRICE1, p30 );
   ObjectSet("up_30", OBJPROP_PRICE2, p40 );
   ObjectSet("up_30", OBJPROP_COLOR, up_col_2);
      
   ObjectDelete(0,"up_40");
   ObjectCreate(0,"up_40",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_40", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("up_40", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("up_40", OBJPROP_PRICE1, p40 );
   ObjectSet("up_40", OBJPROP_PRICE2, p50 );
   ObjectSet("up_40", OBJPROP_COLOR, up_col_3);

   ObjectDelete(0,"up_50");
   ObjectCreate(0,"up_50",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_50", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("up_50", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("up_50", OBJPROP_PRICE1, p50 );
   ObjectSet("up_50", OBJPROP_PRICE2, p100 );
   ObjectSet("up_50", OBJPROP_COLOR, up_col_4);

   ObjectDelete(0,"up_100");
   ObjectCreate(0,"up_100",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_100", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("up_100", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("up_100", OBJPROP_PRICE1, p100 );
   ObjectSet("up_100", OBJPROP_PRICE2, p150 );
   ObjectSet("up_100", OBJPROP_COLOR, up_col_5);
      
   ObjectDelete(0,"up_ext");
   ObjectCreate(0,"up_ext",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_ext", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("up_ext", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("up_ext", OBJPROP_PRICE1, p150 );
   ObjectSet("up_ext", OBJPROP_PRICE2, WindowPriceMax());
   ObjectSet("up_ext", OBJPROP_COLOR, up_col_6);
         
//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
   
   ObjectDelete(0,"down_20");
   ObjectCreate(0,"down_20",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_20", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("down_20", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("down_20", OBJPROP_PRICE1, dp20 );
   ObjectSet("down_20", OBJPROP_PRICE2, dp30 );
   ObjectSet("down_20", OBJPROP_COLOR, down_col_1);
   
   ObjectDelete(0,"down_30");
   ObjectCreate(0,"down_30",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_30", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("down_30", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("down_30", OBJPROP_PRICE1, dp30 );
   ObjectSet("down_30", OBJPROP_PRICE2, dp40 );
   ObjectSet("down_30", OBJPROP_COLOR, down_col_2);
      
   ObjectDelete(0,"down_40");
   ObjectCreate(0,"down_40",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_40", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("down_40", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("down_40", OBJPROP_PRICE1, dp40 );
   ObjectSet("down_40", OBJPROP_PRICE2, dp50 );
   ObjectSet("down_40", OBJPROP_COLOR, down_col_3);

   ObjectDelete(0,"down_50");
   ObjectCreate(0,"down_50",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_50", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("down_50", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("down_50", OBJPROP_PRICE1, dp50 );
   ObjectSet("down_50", OBJPROP_PRICE2, dp100 );
   ObjectSet("down_50", OBJPROP_COLOR, down_col_4);  

   ObjectDelete(0,"down_100");
   ObjectCreate(0,"down_100",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_100", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("down_100", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("down_100", OBJPROP_PRICE1, dp100 );
   ObjectSet("down_100", OBJPROP_PRICE2, dp150 );
   ObjectSet("down_100", OBJPROP_COLOR, down_col_5);
      
   ObjectDelete(0,"down_ext");
   ObjectCreate(0,"down_ext",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_ext", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("down_ext", OBJPROP_TIME2,  curTime+shift-1+width2);
   ObjectSet("down_ext", OBJPROP_PRICE1, dp150 );
   ObjectSet("down_ext", OBJPROP_PRICE2, WindowPriceMin() );
   ObjectSet("down_ext", OBJPROP_COLOR, down_col_6);
            
//-------------------------------------------------------------------------------

   ObjectDelete(0,"vL_0");
   ObjectCreate(0,"vL_0",OBJ_VLINE,0,0,0,0,0);
   ObjectSet("vL_0", OBJPROP_TIME1,  curTime+shift-1);
   ObjectSet("vL_0", OBJPROP_COLOR,  clrGray);
   ObjectSet("vL_0", OBJPROP_BACK,  true);

   ObjectDelete(0,"vL_1");
   ObjectCreate(0,"vL_1",OBJ_VLINE,0,0,0,0,0);
   ObjectSet("vL_1", OBJPROP_TIME1,  curTime+shift-1+Vwidth);
   ObjectSet("vL_1", OBJPROP_COLOR,  clrGray);
   ObjectSet("vL_1", OBJPROP_BACK,  true);
   
   ObjectDelete(0,"vL_2");
   ObjectCreate(0,"vL_2",OBJ_VLINE,0,0,0,0,0);
   ObjectSet("vL_2", OBJPROP_TIME1,  curTime+shift1-1+Vwidth);
   ObjectSet("vL_2", OBJPROP_COLOR,  clrGray);
   ObjectSet("vL_2", OBJPROP_BACK,  true);
   
   ObjectDelete(0,"vL_3");
   ObjectCreate(0,"vL_3",OBJ_VLINE,0,0,0,0,0);
   ObjectSet("vL_3", OBJPROP_TIME1,  curTime+shift2-1+Vwidth);
   ObjectSet("vL_3", OBJPROP_COLOR,  clrGray);
   ObjectSet("vL_3", OBJPROP_BACK,  true);
   
   ObjectDelete(0,"vL_4");
   ObjectCreate(0,"vL_4",OBJ_VLINE,0,0,0,0,0);
   ObjectSet("vL_4", OBJPROP_TIME1,  curTime+shift3-1+Vwidth);
   ObjectSet("vL_4", OBJPROP_COLOR,  clrGray);
   ObjectSet("vL_4", OBJPROP_BACK,  true);
   
   ObjectDelete(0,"vL_5");
   ObjectCreate(0,"vL_5",OBJ_VLINE,0,0,0,0,0);
   ObjectSet("vL_5", OBJPROP_TIME1,  curTime+shift4-1+Vwidth);
   ObjectSet("vL_5", OBJPROP_COLOR,  clrGray);
   ObjectSet("vL_5", OBJPROP_BACK,  true);
   
//--------------------------------------------- 
//--------------------------------------------------------------------
//   Daily high/low

   double D1_high=iHigh(NULL, PERIOD_D1,0); 
   double D1_low=iLow(NULL, PERIOD_D1,0);     
   
 if (D1_Show_Line==true) 
   { 
   ObjectDelete("High_line");
   ObjectCreate(0,"High_line",OBJ_TREND,0,0,0,0);
   ObjectSet("High_line", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("High_line", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("High_line", OBJPROP_PRICE1, D1_high);
   ObjectSet("High_line", OBJPROP_PRICE2, D1_high);
   ObjectSet("High_line",OBJPROP_STYLE,D1_style);
   ObjectSet("High_line",OBJPROP_COLOR,D1_Highcol);
   ObjectSet("High_line",OBJPROP_RAY,false);
   
   ObjectDelete("Low_line");
   ObjectCreate(0,"Low_line",OBJ_TREND,0,0,0,0);
   ObjectSet("Low_line", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Low_line", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Low_line", OBJPROP_PRICE1, D1_low);
   ObjectSet("Low_line", OBJPROP_PRICE2, D1_low);
   ObjectSet("Low_line",OBJPROP_STYLE,D1_style);
   ObjectSet("Low_line",OBJPROP_COLOR,D1_Lowcol);
   ObjectSet("Low_line",OBJPROP_RAY,false);
   }
   

 if (D1_Show_Price==true) 
   { 
   ObjectDelete("High_price");
   ObjectCreate(0,"High_price",OBJ_HLINE,0,0,D1_high);
   ObjectSet("High_price",OBJPROP_STYLE,5);
   ObjectSet("High_price",OBJPROP_COLOR,D1_Highcol);
   
   ObjectDelete("Low_price");
   ObjectCreate(0,"Low_price",OBJ_HLINE,0,0,D1_low);
   ObjectSet("Low_price",OBJPROP_STYLE,5);
   ObjectSet("Low_price",OBJPROP_COLOR,D1_Lowcol);
   }


if (show_Fibo_Line==true){

   double R3,R2,R1,Pivot,S1,S2,S3;

   Pivot = ( D1_high + D1_low + price ) / 3;
   
   R3 = Pivot + 1.000 * (D1_high - D1_low);
   R2 = Pivot + 0.618 * (D1_high - D1_low);
   R1 = Pivot + 0.382 * (D1_high - D1_low);

   S1 = Pivot - 0.382 * (D1_high - D1_low);
   S2 = Pivot - 0.618 * (D1_high - D1_low);
   S3 = Pivot - 1.000 * (D1_high - D1_low);
   
   objName=uniqueid+"Pivot";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],Pivot,Time[0],Pivot);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibPVColor);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"Pivot_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],Pivot);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"PV");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibPVColor);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   //---------------------------------------------------------
   
   objName=uniqueid+"R3";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R3,Time[0],R3);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibR3Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"R3_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],R3);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"R3");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibR3Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   //---------------------------------------------------------
   
   objName=uniqueid+"R2";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R2,Time[0],R2);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibR2Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"R2_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],R2);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"R2");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibR2Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
 
 //---------------------------------------------------------
   
   objName=uniqueid+"R1";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R1,Time[0],R1);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibR1Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"R1_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],R1);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"R1");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibR1Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false); 
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S3";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S3,Time[0],S3);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibS3Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"S3_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],S3);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"S3");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibS3Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S2";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S2,Time[0],S2);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibS2Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"S2_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],S2);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"S2");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibS2Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S1";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S1,Time[0],S1);
   ObjectSet(objName,OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,fibS1Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
   
   objName=uniqueid+"S1_TXT";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TEXT,0,Time[110],S1);
   ObjectSetString(NULL,objName,OBJPROP_TEXT,"S1");
   ObjectSetString(NULL,objName,OBJPROP_FONT,"Arial");
   ObjectSet(objName,OBJPROP_FONTSIZE,6);
   ObjectSet(objName, OBJPROP_ANCHOR,1); 
   ObjectSet(objName,OBJPROP_COLOR,clrBlack);
   ObjectSet(objName,OBJPROP_COLOR,fibS1Color);
   ObjectSet(objName,OBJPROP_SELECTABLE,false);
}


//--------------------------------------------------------------------
//   Daily Info

 if (Show_Daily_Info==true)
   { 
   double  D1_open=iOpen(NULL, PERIOD_D1,0); 
   double  D1_Range=(D1_high-D1_low)/Point;
   double  D1_Change=(Bid-D1_open)/Point;
   
   color D1CCol;
   
   if (Bid > D1_open)D1CCol= clrGreen;
   if (Bid < D1_open)D1CCol= clrFireBrick;   
   
      ObjectCreate(0,"D1Range",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"D1Range",OBJPROP_CORNER,0);
   ObjectSetInteger(0,"D1Range",OBJPROP_BORDER_COLOR,C'155,155,155');
   ObjectSetInteger(0,"D1Range",OBJPROP_BGCOLOR,clrDarkGray);
   ObjectSetInteger(0,"D1Range",OBJPROP_XDISTANCE,12);
   ObjectSetInteger(0,"D1Range",OBJPROP_YDISTANCE,-1);
   ObjectSetInteger(0,"D1Range",OBJPROP_XSIZE,40);
   ObjectSetInteger(0,"D1Range",OBJPROP_YSIZE,15);
   ObjectSetInteger(0,"D1Range",OBJPROP_COLOR,Black);
   ObjectSetInteger(0,"D1Range",OBJPROP_FONTSIZE,8);
   ObjectSetString(0,"D1Range",OBJPROP_TEXT,DoubleToString(NormalizeDouble(D1_Range / divider, 1), x_digits));
   ObjectSetInteger(0,"D1Range",OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"D1Range",OBJPROP_HIDDEN,True); 
   
    ObjectCreate(0,"D1Change",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"D1Change",OBJPROP_CORNER,0);
   ObjectSetInteger(0,"D1Change",OBJPROP_BORDER_COLOR,C'155,155,155');
   ObjectSetInteger(0,"D1Change",OBJPROP_BGCOLOR,clrDarkGray);
   ObjectSetInteger(0,"D1Change",OBJPROP_XDISTANCE,52);
   ObjectSetInteger(0,"D1Change",OBJPROP_YDISTANCE,-1);
   ObjectSetInteger(0,"D1Change",OBJPROP_XSIZE,40);
   ObjectSetInteger(0,"D1Change",OBJPROP_YSIZE,15);
   ObjectSetInteger(0,"D1Change",OBJPROP_COLOR,D1CCol);
   ObjectSetInteger(0,"D1Change",OBJPROP_FONTSIZE,8);
   ObjectSetString(0,"D1Change",OBJPROP_TEXT,DoubleToString(NormalizeDouble(D1_Change / divider, 1), x_digits));
   ObjectSetInteger(0,"D1Change",OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"D1Change",OBJPROP_HIDDEN,True); 
   }
   return(0);
}


void drawTimeFrameHeader(){
   // Time frame text
   double oldZoomState=zoomState;
   zoomState=ChartGetInteger(0,CHART_SCALE);;   
   if (zoomState==oldZoomState) return;
   double distance=pow(2,zoomState)*(Width2+2);
   
   objName=uniqueid+"TF_BG";
   ObjectDelete(NULL,objName);
   ObjectCreate(NULL,objName, OBJ_RECTANGLE_LABEL, 1, 0, 0);
   ObjectSetInteger(NULL,objName,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   ObjectSetInteger(NULL,objName,OBJPROP_XDISTANCE,distance);
   ObjectSetInteger(NULL,objName,OBJPROP_YDISTANCE,0);
   ObjectSetInteger(NULL,objName,OBJPROP_XSIZE,distance);
   ObjectSetInteger(NULL,objName,OBJPROP_YSIZE,14);
   ObjectSetInteger(NULL,objName,OBJPROP_COLOR,Black);
   ObjectSetInteger(NULL,objName,OBJPROP_BGCOLOR,DarkGray);
   ObjectSetInteger(0,objName,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSetInteger(0,objName,OBJPROP_BACK,false);
   ObjectSetInteger(0,objName,OBJPROP_BORDER_TYPE,BORDER_RAISED);
   ObjectSetInteger(0,objName,OBJPROP_SELECTABLE,0);

   
   for (tf=0;tf<NTF;tf++){   
      distance=pow(2,zoomState)*Width*(NTF-tf);
      objName = uniqueid+"TF_"+tf;
      ObjectDelete(objName);
      ObjectCreate(objName ,OBJ_LABEL, 1, 0, 0, 0, 0);
      
      ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
      ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,7);
      ObjectSetInteger(NULL,objName,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      
      ObjectSet(objName, OBJPROP_XDISTANCE,distance);   
      ObjectSet(objName, OBJPROP_YDISTANCE, 0 );    
      ObjectSet(objName, OBJPROP_COLOR, Black);
      ObjectSet(objName, OBJPROP_BACK,false);
           
      int val=tfp[tf]/60;
      if (val<1) ObjectSetText(objName, IntegerToString(tfp[tf])+"M");
      else if (val==1) ObjectSetText(objName,"1H");
      else if (val==4) ObjectSetText(objName, "4H");
      else if (val==24) ObjectSetText(objName, "1D");
      else if (val==168) ObjectSetText(objName, "1W"); 
      else if (val>=730) ObjectSetText(objName, "MN");
   }
}


int GetExtremumZZBar(string sy="", int tfr=0,int MA=21, int ne=0) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int j, k=iBars(sy, tfr), ke=0;

  for (j=1; j<k; j++) {
    zz=iCustom(sy, tf, "ZigZag", MA,5,3, 0,j);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(j);
    }
  }
  return(-1);
}